<template>
  <el-dropdown
    v-if="languages.length > 0"
    :trigger="
      !isMobile && themeColor.Text !== 'main_lightblue' ? 'hover' : 'click'
    "
  >
    <div class="flex items-center justify-between cursor-pointer gap-2 global-language-selector">
      <div :class="isMobile ? 'icon-lang-mobile' : 'icon-lang'">
        <img
          :src="
            getAssetImage(
              `assets/materials/languageIcon/${
                selectedLang ?? defaultLanguage
              }.svg`
            )
          "
        />
      </div>
      <div class="flex items-center gap-[2px]">
        <span>{{ reactiveLanguageShortCodeForDisplay }}</span>
        <el-icon style="width: 1rem; height: 1rem">
          <ArrowDown />
        </el-icon>
      </div>
    </div>
    <template #dropdown>
      <div>
        <el-dropdown-menu class="bg-background1">
          <el-dropdown-item
            v-for="lang in languages"
            :key="lang"
            @click="switchLanguage(lang.ISO)"
          >
            <div>{{ lang.LanguageLocalName }}</div>
          </el-dropdown-item>
        </el-dropdown-menu>
      </div>
    </template>
  </el-dropdown>
</template>
<script lang="ts">
import { computed, defineComponent } from "vue";
import { ArrowDown } from "@element-plus/icons-vue";
import { useLanguageComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

export default defineComponent({
  name: "LanguageComponent",
  components: { ArrowDown },
  setup() {
    const isMobile = !useIsDesktop();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const themeColor = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "theme_color"
        )
    );
    const { getAssetImage } = commonHelper;
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      isLanguageLoading,
      languageSetting,
      languageShortCodeForDisplay,
      selectedLang,
      reactiveLanguageShortCodeForDisplay,
    } = useLanguageComponent();
    return {
      languages,
      defaultLanguage,
      switchLanguage,
      isLanguageLoading,
      languageSetting,
      getAssetImage,
      isMobile,
      themeColor,
      languageShortCodeForDisplay,
      selectedLang,
      reactiveLanguageShortCodeForDisplay,
    };
  },
});
</script>
<style scoped lang="scss">
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: cover;
  }

  height: 24px;
  width: 24px;
  border-radius: 50%;
  background: #fff;
}
</style>
<style scoped>
:deep(.el-dropdown-menu__item) {
  --el-dropdown-menuItem-hover-fill: var(--primary);
  --el-dropdown-menuItem-hover-color: #fff;
}

.global-language-selector {
  color: var(--text3);
}
</style>
<style>
[layout="global"] .el-icon svg {
  height: 16px;
  width: 16px;
}
[layout="global"][theme-color="global_sbo"] .global-language-selector {
  color: var(--text5);
}
</style>
